% N Queens
declare
fun {Queens N}
   proc {$ Row}
      L1N ={MakeTuple c N}  
      LM1N={MakeTuple c N}
   in 
      for I in 1..N do L1N.I=I LM1N.I=~I end
	  % L1N = [1 2 3 ... N]
	  % LM1N =[~1 ~2 ... ~N]
      {FD.tuple queens N 1#N Row}
      {FD.distinct Row}
      {FD.distinctOffset Row LM1N}
      {FD.distinctOffset Row L1N}
      {FD.distribute naive Row}
   end 
end
